/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

type Traits struct {
	// Postgres list all required posgres databases
	Postgres map[string]PostgresTrait `json:"postgres,omitempty"`

	// OIDC list all required oidc clients
	OIDC map[string]OIDCTrait `json:"oidc,omitempty"`

	// SAML list all required saml clients
	SAML map[string]SAMLTrait `json:"saml,omitempty"`

	// Bucket list all required s3 buckets
	Bucket map[string]BucketTrait `json:"bucket,omitempty"`
}

type PostgresTrait struct{}

type OIDCTrait struct{}

type SAMLTrait struct{}

type BucketTrait struct{}
