/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	helm "github.com/fluxcd/helm-controller/api/v2beta1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// LibreApplicationSpec defines the desired state of LibreApplication
type LibreApplicationSpec struct {
	// INSERT ADDITIONAL SPEC FIELDS - desired state of cluster
	// Important: Run "make" to regenerate code after modifying this file

	// Chart defines the chart to instantiate
	Chart helm.HelmChartTemplateSpec `json:"chart"`

	// Traits describe requirements managed by the controller
	Traits Traits `json:"traits,omitempty"`
}

// LibreApplicationStatus defines the observed state of LibreApplication
type LibreApplicationStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// LibreApplication is the Schema for the libreapplications API
type LibreApplication struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   LibreApplicationSpec   `json:"spec,omitempty"`
	Status LibreApplicationStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// LibreApplicationList contains a list of LibreApplication
type LibreApplicationList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []LibreApplication `json:"items"`
}

func init() {
	SchemeBuilder.Register(&LibreApplication{}, &LibreApplicationList{})
}
