package v1alpha1

import corev1 "k8s.io/api/core/v1"

type LibreControllerConfig struct {
	KeycloakAccess    KeycloakAccess           `json:"keycloakAccess"`
	BaseTemplatesFrom []StackTemplateReference `json:"baseTemplatesFrom,omitempty"`
	Postgres          PostgresConfig           `json:"postgres,omitempty"`
}

type KeycloakAccess struct {
	Address        string                 `json:"address"`
	RealmName      string                 `json:"realmName"`
	CredentialsRef corev1.SecretReference `json:"credentialsRef"`
}

type PostgresConfig struct {
	SecretSuffix string `json:"secretSuffix,omitempty"`
}
