//go:build !ignore_autogenerated
// +build !ignore_autogenerated

/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by controller-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/api/core/v1"
	apiextensionsv1 "k8s.io/apiextensions-apiserver/pkg/apis/apiextensions/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ApplicationParameters) DeepCopyInto(out *ApplicationParameters) {
	*out = *in
	if in.OIDC != nil {
		in, out := &in.OIDC, &out.OIDC
		*out = make(map[string]OIDCParameters, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.SAML != nil {
		in, out := &in.SAML, &out.SAML
		*out = make(map[string]OIDCParameters, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.Postgres != nil {
		in, out := &in.Postgres, &out.Postgres
		*out = make(map[string]PostgresParameters, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ApplicationParameters.
func (in *ApplicationParameters) DeepCopy() *ApplicationParameters {
	if in == nil {
		return nil
	}
	out := new(ApplicationParameters)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ApplicationTemplate) DeepCopyInto(out *ApplicationTemplate) {
	*out = *in
	out.Application = in.Application
	in.Parameters.DeepCopyInto(&out.Parameters)
	if in.Values != nil {
		in, out := &in.Values, &out.Values
		*out = new(apiextensionsv1.JSON)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ApplicationTemplate.
func (in *ApplicationTemplate) DeepCopy() *ApplicationTemplate {
	if in == nil {
		return nil
	}
	out := new(ApplicationTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BucketTrait) DeepCopyInto(out *BucketTrait) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BucketTrait.
func (in *BucketTrait) DeepCopy() *BucketTrait {
	if in == nil {
		return nil
	}
	out := new(BucketTrait)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *KeycloakAccess) DeepCopyInto(out *KeycloakAccess) {
	*out = *in
	out.CredentialsRef = in.CredentialsRef
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new KeycloakAccess.
func (in *KeycloakAccess) DeepCopy() *KeycloakAccess {
	if in == nil {
		return nil
	}
	out := new(KeycloakAccess)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreApplication) DeepCopyInto(out *LibreApplication) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	out.Status = in.Status
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreApplication.
func (in *LibreApplication) DeepCopy() *LibreApplication {
	if in == nil {
		return nil
	}
	out := new(LibreApplication)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LibreApplication) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreApplicationList) DeepCopyInto(out *LibreApplicationList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]LibreApplication, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreApplicationList.
func (in *LibreApplicationList) DeepCopy() *LibreApplicationList {
	if in == nil {
		return nil
	}
	out := new(LibreApplicationList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LibreApplicationList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreApplicationSpec) DeepCopyInto(out *LibreApplicationSpec) {
	*out = *in
	in.Chart.DeepCopyInto(&out.Chart)
	in.Traits.DeepCopyInto(&out.Traits)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreApplicationSpec.
func (in *LibreApplicationSpec) DeepCopy() *LibreApplicationSpec {
	if in == nil {
		return nil
	}
	out := new(LibreApplicationSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreApplicationStatus) DeepCopyInto(out *LibreApplicationStatus) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreApplicationStatus.
func (in *LibreApplicationStatus) DeepCopy() *LibreApplicationStatus {
	if in == nil {
		return nil
	}
	out := new(LibreApplicationStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreControllerConfig) DeepCopyInto(out *LibreControllerConfig) {
	*out = *in
	out.KeycloakAccess = in.KeycloakAccess
	if in.BaseTemplatesFrom != nil {
		in, out := &in.BaseTemplatesFrom, &out.BaseTemplatesFrom
		*out = make([]StackTemplateReference, len(*in))
		copy(*out, *in)
	}
	out.Postgres = in.Postgres
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreControllerConfig.
func (in *LibreControllerConfig) DeepCopy() *LibreControllerConfig {
	if in == nil {
		return nil
	}
	out := new(LibreControllerConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreStack) DeepCopyInto(out *LibreStack) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreStack.
func (in *LibreStack) DeepCopy() *LibreStack {
	if in == nil {
		return nil
	}
	out := new(LibreStack)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LibreStack) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreStackList) DeepCopyInto(out *LibreStackList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]LibreStack, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreStackList.
func (in *LibreStackList) DeepCopy() *LibreStackList {
	if in == nil {
		return nil
	}
	out := new(LibreStackList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *LibreStackList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreStackSpec) DeepCopyInto(out *LibreStackSpec) {
	*out = *in
	if in.Template != nil {
		in, out := &in.Template, &out.Template
		*out = new(StackTemplate)
		(*in).DeepCopyInto(*out)
	}
	if in.TemplatesFrom != nil {
		in, out := &in.TemplatesFrom, &out.TemplatesFrom
		*out = make([]StackTemplateReference, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreStackSpec.
func (in *LibreStackSpec) DeepCopy() *LibreStackSpec {
	if in == nil {
		return nil
	}
	out := new(LibreStackSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LibreStackStatus) DeepCopyInto(out *LibreStackStatus) {
	*out = *in
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]metav1.Condition, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LibreStackStatus.
func (in *LibreStackStatus) DeepCopy() *LibreStackStatus {
	if in == nil {
		return nil
	}
	out := new(LibreStackStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OIDCParameters) DeepCopyInto(out *OIDCParameters) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OIDCParameters.
func (in *OIDCParameters) DeepCopy() *OIDCParameters {
	if in == nil {
		return nil
	}
	out := new(OIDCParameters)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OIDCTrait) DeepCopyInto(out *OIDCTrait) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OIDCTrait.
func (in *OIDCTrait) DeepCopy() *OIDCTrait {
	if in == nil {
		return nil
	}
	out := new(OIDCTrait)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PostgresConfig) DeepCopyInto(out *PostgresConfig) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PostgresConfig.
func (in *PostgresConfig) DeepCopy() *PostgresConfig {
	if in == nil {
		return nil
	}
	out := new(PostgresConfig)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PostgresParameters) DeepCopyInto(out *PostgresParameters) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PostgresParameters.
func (in *PostgresParameters) DeepCopy() *PostgresParameters {
	if in == nil {
		return nil
	}
	out := new(PostgresParameters)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PostgresTemplate) DeepCopyInto(out *PostgresTemplate) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PostgresTemplate.
func (in *PostgresTemplate) DeepCopy() *PostgresTemplate {
	if in == nil {
		return nil
	}
	out := new(PostgresTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PostgresTrait) DeepCopyInto(out *PostgresTrait) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PostgresTrait.
func (in *PostgresTrait) DeepCopy() *PostgresTrait {
	if in == nil {
		return nil
	}
	out := new(PostgresTrait)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SAMLParameters) DeepCopyInto(out *SAMLParameters) {
	*out = *in
	if in.ServiceCertificateRef != nil {
		in, out := &in.ServiceCertificateRef, &out.ServiceCertificateRef
		*out = new(v1.SecretReference)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SAMLParameters.
func (in *SAMLParameters) DeepCopy() *SAMLParameters {
	if in == nil {
		return nil
	}
	out := new(SAMLParameters)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SAMLTrait) DeepCopyInto(out *SAMLTrait) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SAMLTrait.
func (in *SAMLTrait) DeepCopy() *SAMLTrait {
	if in == nil {
		return nil
	}
	out := new(SAMLTrait)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *SSOTemplate) DeepCopyInto(out *SSOTemplate) {
	*out = *in
	if in.KeycloakAccess != nil {
		in, out := &in.KeycloakAccess, &out.KeycloakAccess
		*out = new(KeycloakAccess)
		**out = **in
	}
	if in.KeycloakRealm != nil {
		in, out := &in.KeycloakRealm, &out.KeycloakRealm
		*out = new(apiextensionsv1.JSON)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new SSOTemplate.
func (in *SSOTemplate) DeepCopy() *SSOTemplate {
	if in == nil {
		return nil
	}
	out := new(SSOTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *StackTemplate) DeepCopyInto(out *StackTemplate) {
	*out = *in
	in.SSO.DeepCopyInto(&out.SSO)
	out.Postgres = in.Postgres
	if in.Applications != nil {
		in, out := &in.Applications, &out.Applications
		*out = make(map[string]ApplicationTemplate, len(*in))
		for key, val := range *in {
			(*out)[key] = *val.DeepCopy()
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new StackTemplate.
func (in *StackTemplate) DeepCopy() *StackTemplate {
	if in == nil {
		return nil
	}
	out := new(StackTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *StackTemplateReference) DeepCopyInto(out *StackTemplateReference) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new StackTemplateReference.
func (in *StackTemplateReference) DeepCopy() *StackTemplateReference {
	if in == nil {
		return nil
	}
	out := new(StackTemplateReference)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Traits) DeepCopyInto(out *Traits) {
	*out = *in
	if in.Postgres != nil {
		in, out := &in.Postgres, &out.Postgres
		*out = make(map[string]PostgresTrait, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.OIDC != nil {
		in, out := &in.OIDC, &out.OIDC
		*out = make(map[string]OIDCTrait, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.SAML != nil {
		in, out := &in.SAML, &out.SAML
		*out = make(map[string]SAMLTrait, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.Bucket != nil {
		in, out := &in.Bucket, &out.Bucket
		*out = make(map[string]BucketTrait, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Traits.
func (in *Traits) DeepCopy() *Traits {
	if in == nil {
		return nil
	}
	out := new(Traits)
	in.DeepCopyInto(out)
	return out
}
